//SENSOR BME280
  #include <Wire.h>
  #include <SPI.h>
  #include <Adafruit_Sensor.h>
  #include <Adafruit_BME280.h>
  #include <SPI.h>
  #include <LoRa.h>



  
  #define SEALEVELPRESSURE_HPA (1013.25)
  Adafruit_BME280 bme; // I2C
  unsigned long delayTime;


//SENSOR MPU9250
  #include "MPU9250.h"
  MPU9250 IMU(Wire,0x68);// an MPU9250 object with the MPU-9250 sensor on I2C bus 0 with address 0x68
  int status;


//SENSOR MQ135
  #include <MQUnifiedsensor.h>  
  #define placa "Arduino UNO"
  #define Voltage_Resolution 5
  #define pin A0 //Analog input 0 of your arduinoQ
  #define type "MQ-135" //MQ135
  #define ADC_Bit_Resolution 10 // For arduino UNO/MEGA/NANO
  #define RatioMQ135CleanAir 3.6//RS / R0 = 3.6 ppm  
  //#define calibration_button 13 //Pin to calibrate your sensor
  MQUnifiedsensor MQ135(placa, Voltage_Resolution, ADC_Bit_Resolution, pin, type);//Declare Sensor


//SENSOR GUVA-S12SD  
  

  

void setup() {

//LORA TX
  if (!LoRa.begin(433E6)) {
    Serial.println("Starting LoRa failed!");
    while (1);
  }
  
 
//SENSOR BME280  
    Serial.begin(9600);
   

    
    unsigned status;
   
    // default settings
    // (you can also pass in a Wire library object like &Wire2)
    status = bme.begin(0x76); 
    if (!status) {
        
        while (1);
    }
   
   
    delayTime = 2000;



//SENSOR MPU9250
    IMU.begin();
    // setting the accelerometer full scale range to +/-8G 
    IMU.setAccelRange(MPU9250::ACCEL_RANGE_8G);
    // setting the gyroscope full scale range to +/-500 deg/s
    IMU.setGyroRange(MPU9250::GYRO_RANGE_500DPS);
    // setting DLPF bandwidth to 20 Hz
    IMU.setDlpfBandwidth(MPU9250::DLPF_BANDWIDTH_20HZ);
    // setting SRD to 19 for a 50 Hz update rate
    IMU.setSrd(19);


//SENSOR MQ135
  
  //Set math model to calculate the PPM concentration and the value of constants
  MQ135.setRegressionMethod(1); //_PPM =  a*ratio^b
  
  /*****************************  MQ Init ********************************************/ 
  //Remarks: Configure the pin of arduino as input.
  /************************************************************************************/ 
  MQ135.init(); 
  /* 
    //If the RL value is different from 10K please assign your RL value with the following method:
    MQ135.setRL(10);
  */
  /*****************************  MQ CAlibration ********************************************/ 
  // Explanation: 
  // In this routine the sensor will measure the resistance of the sensor supposing before was pre-heated
  // and now is on clean air (Calibration conditions), and it will setup R0 value.
  // We recomend execute this routine only on setup or on the laboratory and save on the eeprom of your arduino
  // This routine not need to execute to every restart, you can load your R0 if you know the value
  // Acknowledgements: https://jayconsystems.com/blog/understanding-a-gas-sensor
  
  float calcR0 = 0;
  for(int i = 1; i<=10; i ++)
  {
    MQ135.update(); // Update data, the arduino will be read the voltage on the analog pin
    calcR0 += MQ135.calibrate(RatioMQ135CleanAir);
    
  }
  MQ135.setR0(calcR0/10);
  
  
  if(isinf(calcR0)) { while(1);}
  if(calcR0 == 0){ while(1);}
  /*****************************  MQ CAlibration ********************************************/ 


//SENSOR GUVA-S12SD

  
  
}





void loop() {
    printValues();
    delay(delayTime);
}

//SENSOR BME280 
void printValues() {

    String Temperatura=(String)bme.readTemperature();


    String Presion=(String)(bme.readPressure()/100.0F);

    String Altitud=(String)(bme.readAltitude(SEALEVELPRESSURE_HPA));


    String Humedad=(String)bme.readHumidity();

  
//SENSOR GUVA-S12SD
  float sensorVoltage;
  float sensorValue; 
  sensorValue = analogRead(A1);
  sensorVoltage = sensorValue/1024*3.3;
  String Luz=(String)(sensorValue);

  


//SENSOR MPU9250
  // read the sensor
    IMU.readSensor();
  
    // display the data    
    String AcelX=(String)(IMU.getAccelX_mss());
    String AcelY=(String)(IMU.getAccelY_mss());
    String AcelZ=(String)(IMU.getAccelZ_mss());
    String GiroX=(String)(IMU.getGyroX_rads());
    String GiroY=(String)(IMU.getGyroY_rads());
    String GiroZ=(String)(IMU.getGyroZ_rads());
    String MagnX=(String)(IMU.getMagX_uT());
    String MagnY=(String)(IMU.getMagY_uT());
    String MagnZ=(String)(IMU.getMagZ_uT());
    String TempAcel=(String)(IMU.getTemperature_C());

 
//SENSOR MQ135
  MQ135.update(); // Update data, the arduino will be read the voltage on the analog pin

  MQ135.setA(605.18); MQ135.setB(-3.937); // Configurate the ecuation values to get CO concentration
  float CO = MQ135.readSensor(); // Sensor will read PPM concentration using the model and a and b values setted before or in the setup

  MQ135.setA(77.255); MQ135.setB(-3.18); // Configurate the ecuation values to get Alcohol concentration
  float Alcohol = MQ135.readSensor(); // Sensor will read PPM concentration using the model and a and b values setted before or in the setup

  MQ135.setA(110.47); MQ135.setB(-2.862); // Configurate the ecuation values to get CO2 concentration
  float CO2 = MQ135.readSensor(); // Sensor will read PPM concentration using the model and a and b values setted before or in the setup

  MQ135.setA(44.947); MQ135.setB(-3.445); // Configurate the ecuation values to get Tolueno concentration
  float Tolueno = MQ135.readSensor(); // Sensor will read PPM concentration using the model and a and b values setted before or in the setup

  MQ135.setA(102.2 ); MQ135.setB(-2.473); // Configurate the ecuation values to get NH4 concentration
  float NH4 = MQ135.readSensor(); // Sensor will read PPM concentration using the model and a and b values setted before or in the setup

  MQ135.setA(34.668); MQ135.setB(-3.369); // Configurate the ecuation values to get Acetona concentration
  float Acetona = MQ135.readSensor(); // Sensor will read PPM concentration using the model and a and b values setted before or in the setup

  
  String CO_dato=(String)(CO);   
  String Alcohol_dato=(String)(Alcohol);
  String CO2_dato=(String)(CO2);
  String Tolueno_dato=(String)(Tolueno);
  String NH4_dato=(String)(NH4);
  String Acetona_dato=(String)(Acetona);



//PARA NODE RED
  int Ndata=6;
  String str_Payload;

  //Crea un string con el formato: NData Data1 Data2 Data3 ... DataN
  str_Payload += Temperatura;
  str_Payload += " "+Presion;
  str_Payload += " "+Altitud;
  str_Payload += " "+Humedad;
  
  str_Payload += " "+Luz;
      
  str_Payload += " "+AcelX;
  str_Payload += " "+AcelY;
  str_Payload += " "+AcelZ;
  str_Payload += " "+GiroX;
  str_Payload += " "+GiroY;
  str_Payload += " "+GiroZ;
  str_Payload += " "+MagnX;
  str_Payload += " "+MagnY;
  str_Payload += " "+MagnZ;

  str_Payload += " "+CO_dato;
  str_Payload += " "+Alcohol_dato;
  str_Payload += " "+CO2_dato;
  str_Payload += " "+Tolueno_dato;
  str_Payload += " "+NH4_dato;
  str_Payload += " "+Acetona_dato;

  str_Payload += " ";
  str_Payload += "\n";

//Envio mediante Lora
  LoRa.beginPacket();
  LoRa.print(str_Payload);
  LoRa.endPacket();  
  
}
